HDU 6024 女生专场 Building Shops 【简单dp】

Building Shops 
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 131072/131072 K (Java/Others) 
Total Submission(s): 701 Accepted Submission(s): 265

Problem Description 
HDU’s n classrooms are on a line ,which can be considered as a number line. Each classroom has a coordinate. Now Little Q wants to build several candy shops in these n classrooms.

The total cost consists of two parts. Building a candy shop at classroom i would have some cost ci. For every classroom P without any candy shop, then the distance between P and the rightmost classroom with a candy shop on P’s left side would be included in the cost too. Obviously, if there is a classroom without any candy shop, there must be a candy shop on its left side


Now Little Q wants to know how to build the candy shops with the minimal cost. Please write a program to help him.

Input 
The input contains several test cases, no more than 10 test cases. 
In each test case, the first line contains an integer n(1≤n≤3000), denoting the number of the classrooms. 
In the following n lines, each line contains two integers xi,ci(−109≤xi,ci≤109), denoting the coordinate of the i-th classroom and the cost of building a candy shop in it. 
There are no two classrooms having same coordinate.

Output 
For each test case, print a single line containing an integer, denoting the minimal cost.

Sample Input 

1 2 
2 3 
3 4 

1 7 
3 1 
5 10 
6 1

Sample Output 

11

Source 
2017中国大学生程序设计竞赛 - 女生专场

题意: 

读了好久才明白

有n个教室,现在想在这n个教室中建一些超市,问你最少费用为多少? 
费用分为两种: 
1:在第i个教室建超市,费用因为ci 

2:没有建糖果屋的教室的费用为它与左边离它最近的糖果屋的距离

解题思路:

从左到右,只需要O(n*n),遍历一遍,每次只考虑当前教室为最后一个教室然后考虑局部状态,每一个教室只有两种状态,要么建成糖果屋,要么不建。跟背包思路相似,要么放进,要么不放。一个教室 i 建成糖果屋时费用为min(dp[i-1][1],dp[i-1][0])+建成它的费用。教室不建糖果屋费用为它到最近的糖果屋的距离,此时需要枚举在教室 i 前哪个教室建成糖果屋能够使得 i 不建糖果屋时花费最小(因为它前面的第 j 个教室虽然两者距离远,但是建成 j 糖果屋的花费小,所以要枚举)。但每次枚举都要考虑 i到j+1的教室到 j 的距离,复杂度又变成了O(n*n*n),此时只需要 sum+=(i-j)*(a[j+1].first-a[j].first)此公式即可;

  

#include<bits/stdc++.h> 
using namespace std;
typedef long long ll;
#define INF 0x3f3f3f3f
#define Max 3010
typedef pair<ll ,ll > p;
p  a[Max];
ll dp[Max][2];
bool cmp(p x,p y)
{
	return x.first<y.first;
}
int main(){
    int n;
    while(~scanf("%d",&n))
    {
        for(int i=0;i<n;i++)
   	    	scanf("%lld%lld",&a[i].first,&a[i].second);
		sort(a,a+n,cmp);
		dp[0][0]=INF;
		dp[0][1]=a[0].second;
	    for(int i=1;i<n;i++)
		{
			ll sum=0;
		   	dp[i][1]=min(dp[i-1][0],dp[i-1][1])+a[i].second;
		   	dp[i][0]=INF;
			for(int j=i-1;j>=0;j--)
		   	{
		   		sum+=(i-j)*(a[j+1].first-a[j].first);
		   		dp[i][0]=min(dp[i][0],dp[j][1]+sum);
			}
	    } 
		printf("%lld\n",min(dp[n-1][0],dp[n-1][1]));	    
	} 
	return 0; 	  
}
 	




猜你喜欢

转载自blog.csdn.net/pinkair/article/details/79963825